unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Layers32, BitmapImages32, IniFiles, ShellAPI, GDIPOBJ_;

type
  TRStretchButtonLayerControl = packed record
    StretchButtonLayerControl: TStretchButtonLayerControl;
    Normal_state: Single;
    Elevated_state: Single;
    Raised_state: Single;
    Effect_count_step: Integer;
    Interpolation_Style: Integer;
    Command: string[255];
    Picture: string[255];
    Hint: string[255];
  end;

  TForm1 = class(TForm)
    LayerForm1: TLayerForm;
    ImageLayerControl1: TImageLayerControl;
    StretchButtonLayerControl1: TStretchButtonLayerControl;
    StretchButtonLayerControl2: TStretchButtonLayerControl;
    StretchButtonLayerControl3: TStretchButtonLayerControl;
    StretchButtonLayerControl4: TStretchButtonLayerControl;
    StretchButtonLayerControl5: TStretchButtonLayerControl;
    StretchButtonLayerControl6: TStretchButtonLayerControl;
    Bitmaps32List1: TBitmaps32List;
    PopupMenu1: TPopupMenu;
    Close1: TMenuItem;
    Bitmaps32List2: TBitmaps32List;
    Button1: TMenuItem;
    N2: TMenuItem;
    TextLayerControl1: TTextLayerControl;
    ImageLayerControl2: TImageLayerControl;
    procedure LayerForm1ChangeCurrentControl(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageLayerControl1MouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Close1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure StretchButtonLayerControl1EffectEnd(Sender: TObject);
  private
    FRStretchButtonLayerControl: array[0..5] of TRStretchButtonLayerControl;
    FStretchButtonLayerControl1, FStretchButtonLayerControl2: TStretchButtonLayerControl;
  public
    procedure LoadConfig;
    procedure SaveConfig;
    procedure UpdateButtons;
    procedure UpdatePictures;
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FRStretchButtonLayerControl[0].StretchButtonLayerControl := StretchButtonLayerControl1;
  FRStretchButtonLayerControl[1].StretchButtonLayerControl := StretchButtonLayerControl2;
  FRStretchButtonLayerControl[2].StretchButtonLayerControl := StretchButtonLayerControl3;
  FRStretchButtonLayerControl[3].StretchButtonLayerControl := StretchButtonLayerControl4;
  FRStretchButtonLayerControl[4].StretchButtonLayerControl := StretchButtonLayerControl5;
  FRStretchButtonLayerControl[5].StretchButtonLayerControl := StretchButtonLayerControl6;
  FStretchButtonLayerControl1 := nil;
  FStretchButtonLayerControl2 := nil;
  LoadConfig;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SaveConfig;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  LayerForm1.FormNormalState := fsLeft;
  ImageLayerControl1.Effect.Image := 1;
  UpdateButtons;
  UpdatePictures;
end;

procedure TForm1.LayerForm1ChangeCurrentControl(Sender: TObject);
var
  I: Integer;
begin
  ImageLayerControl2.Visible := False;
  TextLayerControl1.Visible := False;
  if (LayerForm1.CurrentControl = nil) or
    (LayerForm1.CurrentControl = ImageLayerControl2) or
    (LayerForm1.CurrentControl = TextLayerControl1) then
  begin
    for I := 0 to 5 do FRStretchButtonLayerControl[I].StretchButtonLayerControl.Visible := False;
    ImageLayerControl1.Effect.Image := 1;
  end
  else
  begin
    if LayerForm1.CurrentControl is TImageLayerControl then
    begin
      for I := 0 to 5 do
        with FRStretchButtonLayerControl[I] do StretchButtonLayerControl.Effect.StretchNormal := Normal_state;
    end
    else
    if LayerForm1.CurrentControl is TStretchButtonLayerControl then
    begin
      with (LayerForm1.CurrentControl as TStretchButtonLayerControl) do
      begin
        Effect.StretchNormal := FRStretchButtonLayerControl[Tag].Elevated_state;
        case Tag of
          0: begin
            FStretchButtonLayerControl1 := FRStretchButtonLayerControl[1].StretchButtonLayerControl;
            FStretchButtonLayerControl1.Effect.StretchNormal := FRStretchButtonLayerControl[1].Elevated_state;
            FStretchButtonLayerControl2 := nil;
          end;
          5: begin
            FStretchButtonLayerControl2 := FRStretchButtonLayerControl[4].StretchButtonLayerControl;
            FRStretchButtonLayerControl[4].StretchButtonLayerControl.Effect.StretchNormal := FRStretchButtonLayerControl[4].Elevated_state;
            FStretchButtonLayerControl1 := nil;
          end;
          else
          begin
            FStretchButtonLayerControl1 := FRStretchButtonLayerControl[Tag - 1].StretchButtonLayerControl;
            FStretchButtonLayerControl2 := FRStretchButtonLayerControl[Tag + 1].StretchButtonLayerControl;
            FStretchButtonLayerControl1.Effect.StretchNormal := FRStretchButtonLayerControl[Tag - 1].Elevated_state;
            FStretchButtonLayerControl2.Effect.StretchNormal := FRStretchButtonLayerControl[Tag + 1].Elevated_state;
          end;
        end;
        OnEffectEnd := StretchButtonLayerControl1EffectEnd;
      end;
      for I := 0 to 5 do
        with FRStretchButtonLayerControl[I] do
          if (StretchButtonLayerControl <> LayerForm1.CurrentControl) then
          begin
            StretchButtonLayerControl.OnEffectEnd := nil;
            if (StretchButtonLayerControl <> FStretchButtonLayerControl1) and
               (StretchButtonLayerControl <> FStretchButtonLayerControl2) then StretchButtonLayerControl.Effect.StretchNormal := Normal_state;
          end;
    end;
    for I := 0 to 5 do FRStretchButtonLayerControl[I].StretchButtonLayerControl.Visible := True;
    ImageLayerControl1.Effect.Image := 0;
  end;
end;

procedure TForm1.StretchButtonLayerControl1EffectEnd(Sender: TObject);
begin
  with Sender as TStretchButtonLayerControl do
    if Hint <> '' then
    begin
      ImageLayerControl2.Top := Top + (Height - ImageLayerControl2.Height) div 2;
      TextLayerControl1.Top := ImageLayerControl2.Top + (ImageLayerControl2.Height - TextLayerControl1.Height) div 2 - 2;
      TextLayerControl1.Caption := Hint;
      ImageLayerControl2.Visible := Visible and (LayerForm1.CurrentControl = Sender);
      TextLayerControl1.Visible := Visible and (LayerForm1.CurrentControl = Sender);
    end;
end;

procedure TForm1.ImageLayerControl1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ACommand: String;
begin
  if Button = mbRight then (Sender as TCustomLayerControl).PopupAtCursor
  else
    if Sender is TStretchButtonLayerControl then
      with FRStretchButtonLayerControl[(Sender as TStretchButtonLayerControl).Tag] do
      begin
        ACommand := Command;
        if ACommand <> '' then ShellExecute(0, 'open', PChar(ACommand), nil, nil, SW_SHOWNORMAL);
      end;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.LoadConfig;
var
  I: Integer;
begin
  with TIniFile.Create(ExtractFilePath(Application.ExeName) + 'config.ini') do
    try
      for I := 0 to 5 do
        with FRStretchButtonLayerControl[I] do
        begin
          Normal_state := ReadFloat('button' + IntToStr(I), 'Normal_state', 0.7);
          Elevated_state := ReadFloat('button' + IntToStr(I), 'Elevated_state', 0.8);
          Raised_state := ReadFloat('button' + IntToStr(I), 'Raised_state', 1);
          Effect_count_step := ReadInteger('button' + IntToStr(I), 'Effect_count_step', 20);
          Interpolation_Style := ReadInteger('button' + IntToStr(I), 'Interpolation_Style', 8);
          Picture := ReadString('button' + IntToStr(I), 'Picture', '');
          Command := ReadString('button' + IntToStr(I), 'Command', '');
          Hint := ReadString('button' + IntToStr(I), 'Hint', '');
        end;
    finally
      Free;
    end;
end;

procedure TForm1.SaveConfig;
var
  I: Integer;
begin
  with TIniFile.Create(ExtractFilePath(Application.ExeName) + 'config.ini') do
    try
      for I := 0 to 5 do
        with FRStretchButtonLayerControl[I] do
        begin
          WriteFloat('button' + IntToStr(I), 'Normal_state', Normal_state);
          WriteFloat('button' + IntToStr(I), 'Elevated_state', Elevated_state);
          WriteFloat('button' + IntToStr(I), 'Raised_state', Raised_state);
          WriteInteger('button' + IntToStr(I), 'Effect_count_step', Effect_count_step);
          WriteInteger('button' + IntToStr(I), 'Interpolation_Style', Interpolation_Style);
          WriteString('button' + IntToStr(I), 'Picture', Picture);
          WriteString('button' + IntToStr(I), 'Command', Command);
          WriteString('button' + IntToStr(I), 'Hint', Hint);
        end;
    finally
      Free;
    end;
end;

procedure TForm1.UpdateButtons;
var
  I: Integer;
begin
  for I := 0 to 5 do
    with FRStretchButtonLayerControl[I] do
    begin
      with StretchButtonLayerControl.Effect do
      begin
        StretchNormal := Normal_state;
        StretchOver := Raised_state;
        StretchDown := Raised_state;
        EffectCountStep := Effect_count_step;
        InterpolationStyle := TInterpolationStyle(Interpolation_Style);
      end;
      StretchButtonLayerControl.Hint := Hint;
    end;
end;

procedure TForm1.UpdatePictures;

procedure LoadBitmap(Dest: TBitmap32; FileName: string);
var
  AGPBitmap: TGPBitmap;
begin
  if FileExists(FileName) then
    if LoadFromFile(AGPBitmap, FileName) then
      try
        Dest.Bitmap := AGPBitmap;
      finally
        FreeAndNil(AGPBitmap);
      end;
end;

var
  I: Integer;
begin
  with Bitmaps32List2.Images do
  begin
    Clear;
    for I := 0 to 5 do
      with Add do LoadBitmap(Bitmap32, ExtractFilePath(Application.ExeName) + 'picture\' + FRStretchButtonLayerControl[I].Picture);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
begin
  with TForm2.Create(Self) do
  begin
    for I := 0 to 5 do Move(Self.FRStretchButtonLayerControl[I], FRStretchButtonLayerControl[I], SizeOf(TRStretchButtonLayerControl));
    Bitmaps32List2.Assign(Self.Bitmaps32List2);
    UpdateList;
    ListClick;
    if ShowModal = mrOk then
    begin
      for I := 0 to 5 do Move(FRStretchButtonLayerControl[I], Self.FRStretchButtonLayerControl[I], SizeOf(TRStretchButtonLayerControl));
      Self.Bitmaps32List2.Assign(Bitmaps32List2);
      UpdateButtons;
      UpdatePictures;
    end;
  end;
end;

end.
