unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, StdCtrls, Buttons, ExtCtrls, BitmapImages32, ActnList,
  ExtDlgs, GDIPOBJ_, Layers32, Unit1;

type
  TForm2 = class(TForm)
    SpeedButton3: TSpeedButton;
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Bevel1: TBevel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    ActionList1: TActionList;
    Action3: TAction;
    Panel1: TPanel;
    Label10: TLabel;
    Label1: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    edt1: TEdit;
    lbl1: TLabel;
    lbl2: TLabel;
    edt2: TEdit;
    lbl5: TLabel;
    ComboBox1: TComboBox;
    lbl6: TLabel;
    lbl7: TLabel;
    lbl3: TLabel;
    edt5: TEdit;
    edt6: TEdit;
    edt3: TEdit;
    lbl4: TLabel;
    edt4: TEdit;
    Bitmaps32List2: TBitmaps32List;
    procedure ActionList1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure Action3Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Action5Execute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure edt1Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure edt2Change(Sender: TObject);
    procedure edt5Change(Sender: TObject);
    procedure edt6Change(Sender: TObject);
    procedure edt3Change(Sender: TObject);
    procedure edt4Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  protected
    procedure DrawBackground(Canvas: TCanvas; AWidth, AHeight: Integer);
    procedure Draw;
  public
    FRStretchButtonLayerControl: array[0..5] of TRStretchButtonLayerControl;
    procedure UpdateList;
    procedure ListClick;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.FormCreate(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TForm2.UpdateList;
var
  I: Integer;
begin
  with ListBox1 do
  begin
    Items.BeginUpdate;
    try
      Items.Clear;
      for I := 0 to 5 do
      begin
        Items.Add(FRStretchButtonLayerControl[I].StretchButtonLayerControl.Name);
      end;
    finally
      Items.EndUpdate;
    end;
  end;
end;

procedure TForm2.ListClick;
begin
  ListBox1.Selected[0] := True;
  ListBox1Click(nil);
end;

procedure TForm2.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
var
  AEnable: Boolean;
begin
  AEnable := ListBox1.ItemIndex <> -1;
  Action3.Enabled := AEnable;
  edt1.Enabled := AEnable;
  edt2.Enabled := AEnable;
  edt5.Enabled := AEnable;
  edt6.Enabled := AEnable;
  edt3.Enabled := AEnable;
  edt4.Enabled := AEnable;
  ComboBox1.Enabled := AEnable;
end;

procedure TForm2.Action3Execute(Sender: TObject);
var
  ASource, ADest: string;
  AGPBitmap: TGPBitmap;
begin
  with OpenPictureDialog1 do
    if Execute then
    begin
      ASource := FileName;
      ADest := ExtractFilePath(Application.ExeName) + 'picture\' + ExtractFileName(FileName);
      CopyFile(Pchar(ASource), Pchar(ADest), False);
      if LoadFromFile(AGPBitmap, FileName) then
        try
          with FRStretchButtonLayerControl[ListBox1.ItemIndex].StretchButtonLayerControl do
            Images.Bitmap32[Effect.Image].Bitmap := AGPBitmap;
          FRStretchButtonLayerControl[ListBox1.ItemIndex].Picture := ExtractFileName(FileName);
          ListBox1Click(nil);
        finally
          FreeAndNil(AGPBitmap);
        end;
    end;
end;

procedure TForm2.Action5Execute(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TForm2.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex <> -1 then
  begin
    with FRStretchButtonLayerControl[ListBox1.ItemIndex] do
    begin
      Image1.Picture.Bitmap.Width := StretchButtonLayerControl.Images.Bitmap32[StretchButtonLayerControl.Effect.Image].Width;
      Image1.Picture.Bitmap.Height := StretchButtonLayerControl.Images.Bitmap32[StretchButtonLayerControl.Effect.Image].Height;
      Image1.Width := Image1.Picture.Bitmap.Width;
      Image1.Height := Image1.Picture.Bitmap.Height;
      Label1.Caption := Format('Size: %d x %d', [Image1.Picture.Bitmap.Width, Image1.Picture.Bitmap.Height]);
      edt5.Text := FloatToStrF(Normal_state, ffFixed, 4, 2);
      edt6.Text := FloatToStrF(Elevated_state, ffFixed, 4, 2);
      edt3.Text := FloatToStrF(Raised_state, ffFixed, 4, 2);
      edt4.Text := IntToStr(Effect_count_step);
      ComboBox1.ItemIndex := Interpolation_Style;
      edt1.Text := Command;
      edt2.Text := Hint;
    end;
    Draw;
  end;
end;

procedure TForm2.DrawBackground(Canvas: TCanvas; AWidth, AHeight: Integer);
const
  Colors: array [Boolean] of TColor = (clWhite, clSilver);
var
  R: TRect;
  I, J: Integer;
  OddY: Integer;
  TilesHorz, TilesVert: Integer;
  TileX, TileY: Integer;
  TileHeight, TileWidth: Integer;
begin
  TileHeight := 13;
  TileWidth := 13;

  TilesHorz := AWidth div TileWidth;
  TilesVert := AHeight div TileHeight;
  TileY := 0;

  for J := 0 to TilesVert do
  begin
    TileX := 0;
    OddY := J and $1;
    for I := 0 to TilesHorz do
    begin
      R.Left := TileX;
      R.Top := TileY;
      R.Right := TileX + TileWidth;
      R.Bottom := TileY + TileHeight;
      Canvas.Brush.Color := Colors[I and $1 = OddY];
      Canvas.FillRect(R);
      Inc(TileX, TileWidth);
    end;
    Inc(TileY, TileHeight);
  end;
end;

procedure TForm2.Draw;
begin
  with TBitmap.Create do
  try
    Width := Image1.Width;
    Height := Image1.Height;
    PixelFormat := pf24bit;
    DrawBackground(Canvas, Width, Height);
    if ListBox1.ItemIndex <> -1 then
      with FRStretchButtonLayerControl[ListBox1.ItemIndex].StretchButtonLayerControl do
        DrawAlphaBlend(Images.Bitmap32[Effect.Image], Canvas.Handle, Images.Bitmap32[Effect.Image].GetRect, Canvas.ClipRect, 255);
    Image1.Picture.Bitmap.Canvas.CopyRect(Canvas.ClipRect, Canvas, Canvas.ClipRect);
  finally
    Free;
  end;
end;

procedure TForm2.BitBtn2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TForm2.edt1Change(Sender: TObject);
begin
  FRStretchButtonLayerControl[ListBox1.ItemIndex].Command := edt1.Text;
end;

procedure TForm2.edt2Change(Sender: TObject);
begin
  FRStretchButtonLayerControl[ListBox1.ItemIndex].Hint := edt2.Text;
end;

procedure TForm2.edt5Change(Sender: TObject);
begin
  try
    FRStretchButtonLayerControl[ListBox1.ItemIndex].Normal_state := StrToFloat((Sender as TEdit).Text);
  except
    on E: Exception do;
  end;
end;

procedure TForm2.edt6Change(Sender: TObject);
begin
  try
    FRStretchButtonLayerControl[ListBox1.ItemIndex].Elevated_state := StrToFloat((Sender as TEdit).Text);
  except
    on E: Exception do;
  end;
end;

procedure TForm2.edt3Change(Sender: TObject);
begin
  try
    FRStretchButtonLayerControl[ListBox1.ItemIndex].Raised_state := StrToFloat((Sender as TEdit).Text);
  except
    on E: Exception do;
  end;
end;

procedure TForm2.edt4Change(Sender: TObject);
begin
  try
    FRStretchButtonLayerControl[ListBox1.ItemIndex].Effect_count_step := StrToInt((Sender as TEdit).Text);
  except
    on E: Exception do;
  end;
end;

procedure TForm2.ComboBox1Change(Sender: TObject);
begin
  FRStretchButtonLayerControl[ListBox1.ItemIndex].Interpolation_Style := ComboBox1.ItemIndex;
end;

end.
